# RUtilにRとPandasのデータフレームを相互に変換する関数を追加+GgSaveを追加（2015/07/12）
# RUtil.pyをすべてのシートで統一した（2015/08/02）
# sageobjの戻り値が辞書型に変更された（2015/08/09）
import time
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt 
from ggplot import *

def RDf2PandaDf(name):
    json_str =  r('toJSON(%s, pretty=FALSE)' % name) 
    return pd.read_json(sageobj(json_str)['DATA'])

def PandaDf2RDf(df, name):
    l = [dict(zip(df.columns, x)) for x in df.values.tolist()]
    json_str = str(l)
    json_str = json_str.replace("'", '\\"')
    r('%s <- fromJSON("%s")' % (name, json_str))
    
def preGraph(pdfFile):
    filename = DATA+pdfFile
    r.pdf(file='"%s"' %filename)
    return pdfFile

def offGraph():
    r.dev_off()
    
def postGraph(pdfFile, fac=0.75):
    r.dev_off()
    width = int(640*fac)
    pngFile = convertPdf2Png(pdfFile)
    html('<img src="%s?%s" width="%spx">'%(pngFile, time.time(), width))

def getGraph(pdfFile, fac=0.75):
    width = int(640*fac)
    pngFile = convertPdf2Png(pdfFile)
    return '<img src="%s?%s" width="%spx">'%(pngFile, time.time(), width)

def convertPdf2Png(pdfFile):
    pngFile = pdfFile.replace(".pdf", ".png")
    result = os.popen("cd %s; convert -density 600 -geometry 1000 %s %s"%(DATA, pdfFile, pngFile)).read()
    # print result
    return pngFile

def toTable(df):
    html.table(df.values.tolist(), header=df.columns.tolist()) 

def showPNG(pngFile, fac=0.75):
    width = int(640*fac)
    html('<img src="%s?%s" width="%spx">'%(pngFile, time.time(), width))

def GgSave(fileName, fac=0.75):
    filePath = DATA + fileName
    ggsave(filePath, dpi=100)
    showPNG(fileName, fac)

def printFile(name):
    fileName = DATA+name
    file = open(fileName)
    txt = file.read(); file.close()
    print txt

import json
def _plist(obj):
    if isinstance(obj, list):
        sys.stdout.write("[")
        for i in range(len(obj)):
            if i != 0: sys.stdout.write(", ")
            orig = json.dumps(obj[i], indent=4)
            sys.stdout.write(eval("u'''%s'''" % orig).encode('utf-8'))
        sys.stdout.write("]\n")